########################################################################
#
# File Name:            Compile.py
#
# Documentation:        http://docs.4suite.org/4SS/Lib/CommandLine.py.html
#
"""
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""


__doc__ = """Compile a 4SS config. The compilied file can then be used in place of the uncompiled config file to boost performance."""

import os,string
from Ft.Server import FTSERVER_NAMESPACE
from Ft.Server.Server import FtServerServerException
from Ft.Server.Console import CommandUtil, Authenticate
from Ft.Server.Core import Constants
from Ft.Server.Core.Lib import ConfigFile
from distutils import dir_util

import cPickle

def Run(options,args):


    props = ConfigFile._ReadAllProperties(fileName=args['original'])
    file = open(args['compiled'],'w')
    file.write(cPickle.dumps(props,1))
    file.close()


def Register():
    from Ft.Lib.CommandLine import Options, Command, Arguments

    cmd = Command.Command('compile',
                          """Compile a 4SS config file.""",
                          '/home/molson/.4ss.cfg /home/molson/.4ss.ccfg',
                          __doc__,
                          function=Run,
                          arguments = [Arguments.RequiredArgument('original',
                                                                  "The path to the original config file.",
                                                                  str),
                                       Arguments.RequiredArgument('compiled',
                                                                  "The path to the compiled config file.",
                                                                  str),
                                       ],
                          options = Options.Options([]),
                          )
    return cmd
