"""
The console command is used to run 4SS from a graphical console.
Currently, only the server functions are supported.
"""

def Run(options, args):
    # default to the graphical console, if possible
    try:
        import Tkinter
        from Ft.Server.Console import TkConsole
        TkConsole.Run()
    except Tkinter.TclError:
        raise ImportError('No window manager present')
    return    


def Register():
    from Ft.Lib.CommandLine import Options, Command, Arguments

    cmd = Command.Command('console',
                          "Use graphical console",
                          '',
                          __doc__,
                          function=Run,
                          arguments = [],
                          )
    return cmd
