from Ft.Server.Console.Widgets import *


class TLogin(TForm):
    def __init__(self, owner):
        TForm.__init__(self, owner,
                       left=213,
                       top=400,
                       borderIcons=[biSystemMenu, biMinimize],
                       borderStyle=bsSingle,
                       caption='Manager Login',
                       clientHeight=102,
                       clientWidth=254,
                       color=clBtnFace,
                       position=poScreenCenter)
        
        self.onShow = self.onLoginShow
        self.label1 = TLabel(self, top=10, left=8, caption='&Username:')
        self.label2 = TLabel(self, top=38, left=8, caption='&Password:')

        self.userName = TEdit(self, top=8, left=85)
        self.password = TEdit(self, top=36, left=85, passwordChar='*')

        self.okBtn = TButton(self, left=34, top=64, caption='OK',
                             default=1,
                             modalResult=mrOk,
                             onClick=self.onOkClick)
        self.quitBtn = TButton(self, left=145, top=64, caption='Quit',
                               modalResult=mrCancel,
                               onClick=self.onQuitClick)

    def onLoginShow(self, sender):
        sender.userName.text = ''
        sender.password.text = ''
        # FIXME - add tab stops to TForm
        sender.userName.focus_set()
        return

    def onQuitClick(self, sender):
        sender.authentication = None
        return

    def onOkClick(self, sender):
        import sha
        userName = sender.userName.text
        password = sha.new(sender.password.text).hexdigest()
        sender.authentication = (userName, password)
        sender.okBtn.modalResult = mrOk
        return

