g_xmlMessages = {XmlServer.UNKNOWN_URI : MessageSource._('URI %(message)s is Unknown'),
                 XmlServer.INVALID_URI : MessageSource._('URI %(message)s is Invalid'),
                 XmlServer.INVALID_ALIAS : MessageSource._('Alias %(message)s is Invalid'),
                 XmlServer.BROKEN_ALIAS : MessageSource._('Alias %(message)s is broken'),
                 XmlServer.VALIDATION_ERROR : MessageSource._('Document validation error %(message)s'),
                 XmlServer.STYLESHEET_PARSE_ERROR : MessageSource._('An error occurred while parsing your stylesheet:\n%(message)s')
                 }


class XmlServerExceptionImp(XmlServer.XmlServerException):
    def __init__(self,code,message):
        XmlServer.XmlServerException.__init__(self,code,message)
        self._message = g_xmlMessages[code]%{'message':message}
    def __str__(self):
        return self._message

CorbaUtil.OverrideException(XmlServerExceptionImp)

class XmlServerParseExceptionImp(XmlServer.ParseException):
    def __init__(self,message,lineNumber,columnNumber):
        XmlServer.ParseException.__init__(self,message,lineNumber,columnNumber)
        self._message = "Parse Exception at line %d column %d: %s" % (lineNumber,columnNumber,message)
    def __str__(self):
        return self._message

CorbaUtil.OverrideException(XmlServerParseExceptionImp)

