########################################################################
#
# File Name:            RawFileProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import omniORB
import FtServerResources
from Ft.Server.Protocols.CORBA import MessageSource
import RepositoryObjectProxy, ContainerMixinProxy
import FtssTypes
import DocDefProxyHelper

#Overidden class
oldBase = omniORB.objrefMapping[FtServerResources.RawFileIf._NP_RepositoryId]
class RawFileProxyIf(oldBase,RepositoryObjectProxy.RepositoryObjectProxyIf):
    base = oldBase

    def applyXslt(self, stylesheets, params=None, ignorePis=1,
                  extParams=None, extModules=None):


        #Map the stylesheets
        if type(stylesheets) not in [type([]),type(())]:
            stylesheets = (stylesheets,)
        stys = []
        for s in stylesheets:
            if type(s) == type(''):
                #It is a URI
                dr = FtssTypes.DocumentReference(FtssTypes.INTERNAL,s,'','')
                stys.append(dr)
            elif hasattr(s,'toStylesheet'):
                #A document reference
                stys.append(DocDefProxyHelper.DocumentReferenceToCorba(s))
            elif hasattr(s,'getUri'):
                #A reference to a document in the system
                dr = FtssTypes.DocumentReference(FtssTypes.INTERNAL,s.getUri(),'','')
                stys.append(dr)

        #Map the params
        newParams = []
        for name,value in params.items():
            newParams.append(FtssTypes.XsltParameter(name,value))

        extModules = extModules or []

        res,imt,newExtParams = self.base.applyXslt(self,stys,newParams,ignorePis,extModules)
        if extParams:
            extParams.update(newExtParams)
        return res,imt

for name,value in RepositoryObjectProxy.RepositoryObjectProxyIf.__dict__.items():
    if name in ['__doc__','base','__module__']:
        continue
    setattr(RawFileProxyIf,name,value)

omniORB.registerObjref(FtServerResources.RawFileIf._NP_RepositoryId, RawFileProxyIf)












