########################################################################
#
# File Name:            RepositoryProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import omniORB
import FtServerResources
from Ft.Server.Protocols.CORBA import MessageSource
import ResourceProxy, ContainerMixinProxy

#Overidden class
oldBase = omniORB.objrefMapping[FtServerResources.RepositoryIf._NP_RepositoryId]
class RepositoryProxyIf(oldBase,ResourceProxy.ResourceProxyIf):
    base = oldBase

for name,value in ResourceProxy.ResourceProxyIf.__dict__.items():
    if name in ['__doc__','base','__module__']:
        continue
    setattr(RepositoryProxyIf,name,value)

for name,value in ContainerMixinProxy.ContainerMixinProxy.__dict__.items():
    if name in ['__doc__','base','__module__']:
        continue
    setattr(RepositoryProxyIf,name,value)



omniORB.registerObjref(FtServerResources.RepositoryIf._NP_RepositoryId, RepositoryProxyIf)












