from Ft.Server.Core import CreationParamsImp
from Ft.Server.Core import DocumentReferenceImp
from Ft.Server.Core import ValidationInfoImp
import FtssTypes


def NssMapsFromCorba(nss):

    newNss = {}
    for ns in nss:
        newNss[ns.prefix] = ns.namespaceURI
    return newNss

def RdfMapFromCorba(rdfMap):
    newMap = []
    for r in rdfMap:
        newMap.append((r.subjectExpression,r.predicateExpression,r.objectExpression))
    return newMap


def CreationParamsFromCorba(cp):

    if cp._class == FtssTypes.XML_DOCUMENT:
        fti = cp.fullTextIndex
        vi = ValidationInfoFromCorba(cp.validationInfo)
        return CreationParamsImp.XmlCreationParams(fti,vi)
    elif cp._class == FtssTypes.XSLT_DOCUMENT:
        fti = cp.fullTextIndex
        return CreationParamsImp.XsltCreationParams(fti,cp.validate,cp.extensionModules)
    elif cp._class == FtssTypes.SCHEMATRON_DOCUMENT:
        fti = cp.fullTextIndex
        return CreationParamsImp.SchematronCreationParams(fti,cp.validate)



def ValidationInfoFromCorba(vi):
    if vi.type == FtssTypes.NONE:
        return ValidationInfoImp.NoValidation()
    elif vi.type == FtssTypes.SCHEMATRON:
        dr = DocumentReferenceFromCorba(vi.validationDoc)
        return ValidationInfoImp.SchematronValidationInfo(dr)
    elif vi.type == FtssTypes.DTD:
        dr = DocumentReferenceFromCorba(vi.validationDoc)
        return ValidationInfoImp.DtdValidationInfo(dr)


def DocumentReferenceFromCorba(dr):
    if dr.type == FtssTypes.DOCUMENT_STRING:
        return DocumentReferenceImp.StringDocumentReference(dr.source,dr.baseUri)
    elif dr.type == FtssTypes.EXTERNAL:
        return DocumentReferenceImp.ExternalDocumentReference(dr.theUri)
    elif dr.type == FtssTypes.INTERNAL:
        return DocumentReferenceImp.InternalDocumentReference(dr.theUri)

