import FtServerResources__POA, FtServerResources

from Ft.Server.Protocols.CORBA.FtOmniorb import OoXmlDocumentImp
from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil
from Ft.Server.Protocols.CORBA.FtOmniorb.Client import DocDefProxyHelper
from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import DocDefCorbaHelper


import FtssTypes

from Ft.Xml import Domlette

class DocumentDefinitionImp(FtServerResources__POA.DocumentDefinitionIf,OoXmlDocumentImp.XmlDocumentImp):


    def getNsMap(self):
        return self._runSafe(self.resource.getNsMap,(),self._mapNsMap)

    def getRdfMaps(self):
        return self._runSafe(self.resource.getRdfMaps,(),self._mapRdfMaps)


    def addBaseDocumentDefinition(self,baseDef):
        return self._runSafe(self._addBaseDocumentDefinition,(baseDef,))

    def addParentDocumentDefinition(self,parentDef):
        return self._runSafe(self._addParentDocumentDefinition,(parentDef,))

    def getBaseDefinitions(self):
        return self._runSafe(self.resource.getBaseDefinitions,(),self._mapResources)

    def getParentDefinitions(self):
        return self._runSafe(self.resource.getParentDefinitions,(),self._mapResources)

    def getCreationParams(self):
        return self._runSafe(self.resource.getCreationParams,(),self._mapCreationParams)

    def getMetaDocumentUris(self):
        return self._runSafe(self.resource.getMetaDocumentUris,())

    def generateStatements(self,uri,src):
        reader = Domlette.DEFAULT_NONVALIDATING_READER()
        dom = reader.fromString(src)
        rt = self._runSafe(self.resource.generateStatements,(uri,dom),self._mapGenerateStatements)
        return rt

    def getAllGeneratedStatements(self):
        return self._runSafe(self.resource.getAllGeneratedStatements,(),self._mapRdfStatements)


    def setNsMap(self,nss):
        nss = DocDefCorbaHelper.NssMapsFromCorba(nss)
        return self._runSafe(self.resource.setNsMap,(nss,))

    def setCreationParams(self,cp):
        cp = DocDefCorbaHelper.CreationParamsFromCorba(cp)
        return self._runSafe(self.resource.setCreationParams,(cp,))

    def setRdfMaps(self,maps):
        maps = DocDefCorbaHelper.RdfMapFromCorba(maps)
        return self._runSafe(self.resource.setRdfMaps,(maps,))



    def _addBaseDocumentDefinition(self,baseDef):
        internalBaseDef = self.resource.fetchResource(baseDef.getUri())
        return self.resource.addBaseDocumentDefinition(internalBaseDef)

    def _addParentDocumentDefinition(self,baseDef):
        internalBaseDef = self.resource.fetchResource(baseDef.getUri())
        return self.resource.addParentDocumentDefinition(internalBaseDef)


    def _mapNsMap(self,nsMap):
        return DocDefProxyHelper.NsMapToCorba(nsMap)

    def _mapRdfMaps(self,rdfMaps):
        return DocDefProxyHelper.RdfMapsToCorba(rdfMaps)


    def _mapCreationParams(self,cp):
        return DocDefProxyHelper.CreationParamsToCorba(cp)

    def _mapGenerateStatements(self,stmts):
        newStmts = []
        for s in stmts:
            newStmts.append(FtssTypes.RdfStatement(s[0],
                                                  s[1],
                                                  s[2],
                                                  '',
                                                  ''))
        return newStmts
            
