import FtssTypes
import FtServerResources__POA, FtServerResources

from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil
from Ft.Rdf import Statement


class RdfModelImp(FtServerResources__POA.RdfModelIf):

    def __init__(self,model):
        self._model = model


    def removePattern(self,
                      subject,
                      predicate,
                      object,
                      statementUri,
                      domain,
                      subjectFlags,
                      predicateFlags,
                      objectFlags,
                      statementUriFlags,
                      domainFlags):

        if not subjectFlags:
            subjectFlags = None
        if not predicateFlags:
            predicateFlags = None
        if not objectFlags:
            objectFlags = None
        if not statementUriFlags:
            statementUriFlags = None
        if not subjectFlags:
            domainFlags = None

        self._model.removePattern(subject,
                                  predicate,
                                  object,
                                  statementUri = statementUri,
                                  domain = domain,
                                  subjectFlags = subjectFlags,
                                  predicateFlags = predicateFlags,
                                  objectFlags = objectFlags,
                                  statementUriFlags = statementUriFlags,
                                  domainFlags = domainFlags)

    def complete(self,
                 subject,
                 predicate,
                 object,
                 statementUri,
                 domain,
                 subjectFlags,
                 predicateFlags,
                 objectFlags,
                 statementUriFlags,
                 domainFlags):

        if not subjectFlags:
            subjectFlags = None
        if not predicateFlags:
            predicateFlags = None
        if not objectFlags:
            objectFlags = None
        if not statementUriFlags:
            statementUriFlags = None
        if not subjectFlags:
            domainFlags = None

        return self._mapStatements(self._model.complete(subject,
                                                        predicate,
                                                        object,
                                                        statementUri = statementUri,
                                                        domain = domain,
                                                        subjectFlags = subjectFlags,
                                                        predicateFlags = predicateFlags,
                                                        objectFlags = objectFlags,
                                                        statementUriFlags = statementUriFlags,
                                                        domainFlags = domainFlags)
                                   )




    def _mapStatements(self,stmts):
        newStmts = []
        for s in stmts:
            newStmts.append(FtssTypes.RdfStatement(s.subject,
                                                  s.predicate,
                                                  s.object,
                                                  s.uri,
                                                  s.domain))
        return newStmts
